diff --git a/pkgmngt/packageManager.xml.rpm b/pkgmngt/packageManager.xml.rpm
new file mode 100644
index 0000000..81f9b46
--- /dev/null
+++ b/pkgmngt/packageManager.xml.rpm
@@ -0,0 +1,2403 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--  Above is a mandatory header for xml files. It must be the first
+line in the file. Change encoding to the one you use on your computer -->
+<!-- $Id$ -->
+<!-- Mandatory DOCTYPE declaration. Fill free to add entities,
+but no external entities in local files, since they would not
+be accessible from JHALFSDIR. Change the document type `article' to
+book if you prefer. That slightly changes the aspect if you render
+it in html -->
+<!DOCTYPE article PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
+  "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY cpio-version         "2.13">
+<!ENTITY elfutils-version     "0.185">
+<!ENTITY libarchive-version   "3.5.1">
+<!ENTITY libassuan-version    "2.5.5">
+<!ENTITY libgpg-error-version "1.42">
+<!ENTITY libgcrypt-version    "1.9.3">
+<!ENTITY libxml2-version      "2.9.12">
+<!ENTITY libxml2-testsuite-version "20130923">
+<!ENTITY lua-version          "5.4.3">
+<!ENTITY lua-minor            "5.4">
+<!ENTITY nettle-version       "3.7.3">
+<!ENTITY pip-version          "21.1.3">
+<!ENTITY popt-version         "1.18">
+<!ENTITY pth-version          "2.0.7">
+<!ENTITY rpm-version          "4.16.1.3">
+<!ENTITY setuptools-version   "56.0.0">
+<!ENTITY sqlite-version       "3.36.0">
+<!ENTITY sqlite-short-version "3360000">
+<!ENTITY unzip-version        "6.0">
+<!ENTITY cpio-url           "https://ftp.gnu.org/gnu/cpio/cpio-&cpio-version;.tar.bz2">
+<!ENTITY elfutils-url       "https://sourceware.org/ftp/elfutils/&elfutils-version;/elfutils-&elfutils-version;.tar.bz2">
+<!ENTITY libarchive-url     "https://github.com/libarchive/libarchive/releases/download/&libarchive-version;/libarchive-&libarchive-version;.tar.xz">
+<!ENTITY libassuan-url      "https://www.gnupg.org/ftp/gcrypt/libassuan/libassuan-&libassuan-version;.tar.bz2">
+<!ENTITY libgpg-error-url   "https://www.gnupg.org/ftp/gcrypt/libgpg-error/libgpg-error-&libgpg-error-version;.tar.bz2">
+<!ENTITY libgcrypt-url      "https://www.gnupg.org/ftp/gcrypt/libgcrypt/libgcrypt-&libgcrypt-version;.tar.bz2">
+<!ENTITY libxml2-url        "http://xmlsoft.org/sources/libxml2-&libxml2-version;.tar.gz">
+<!ENTITY libxml2-testsuite  "xmlts&libxml2-testsuite-version;.tar.gz">
+<!ENTITY libxml2-testsuite-url "https://www.w3.org/XML/Test/&libxml2-testsuite;">
+<!ENTITY lua-url            "https://www.lua.org/ftp/lua-&lua-version;.tar.gz">
+<!ENTITY lua-patch          "lua-&lua-version;-shared_library-1.patch">
+<!ENTITY lua-patch-url      "https://www.linuxfromscratch.org/patches/blfs/svn/&lua-patch;">
+<!ENTITY nettle-url         "https://ftp.gnu.org/gnu/nettle/nettle-&nettle-version;.tar.gz">
+<!ENTITY pip-url            "https://files.pythonhosted.org/packages/4d/0c/3b63fe024414a8a48661cf04f0993d4b2b8ef92daed45636474c018cd5b7/pip-&pip-version;.tar.gz">
+<!ENTITY popt-url           "https://ftp.osuosl.org/pub/rpm/popt/releases/popt-1.x/popt-&popt-version;.tar.gz">
+<!ENTITY pth-url            "https://ftp.gnu.org/gnu/pth/pth-&pth-version;.tar.gz">
+<!ENTITY rpm-url            "https://ftp.osuosl.org/pub/rpm/releases/rpm-4.16.x/rpm-&rpm-version;.tar.bz2">
+<!ENTITY setuptools-url     "https://files.pythonhosted.org/packages/f6/e9/19af16328705915233299f6f1f02db95899fb00c75ac9da4757aa1e5d1de/setuptools-&setuptools-version;.tar.gz">
+<!ENTITY sqlite-url         "https://sqlite.org/2021/sqlite-autoconf-&sqlite-short-version;.tar.gz">
+<!ENTITY sqlite-doc-url     "https://sqlite.org/2021/sqlite-doc-&sqlite-short-version;.zip">
+<!ENTITY unzip-url          "https://downloads.sourceforge.net/infozip/unzip60.tar.gz">
+<!ENTITY unzip-patch        "unzip-6.0-consolidated_fixes-1.patch">
+<!ENTITY unzip-patch-url    "https://www.linuxfromscratch.org/patches/blfs/svn/&unzip-patch;">
+<!ENTITY cpio-md5           "f3438e672e3fa273a7dc26339dd1eed6">
+<!ENTITY elfutils-md5       "2b6e94c2eebc1f2194173e31bca9396e">
+<!ENTITY libarchive-md5     "1f8c29149832baff8bae232fd2f9b0ec">
+<!ENTITY libassuan-md5      "7194453152bb67e3d45da698762b5d6f">
+<!ENTITY libgpg-error-md5   "133fed221ba8f63f5842858a1ff67cb3">
+<!ENTITY libgcrypt-md5      "3fcb490b9b7347344708eeb7b4a95464">
+<!ENTITY libxml2-md5        "f433a39be087a9f0b197eb2307ad9f75">
+<!ENTITY libxml2-testsuite-md5 "ef8fbe0c92efd9a60d7f320e211d10b2">
+<!ENTITY lua-md5            "ef63ed2ecfb713646a7fcc583cf5f352">
+<!ENTITY lua-patch-md5      "2d7ce798932bd2570c356222b0f5d9ba">
+<!ENTITY nettle-md5         "a60273d0fab9c808646fcf5e9edc2e8f">
+<!ENTITY pip-md5            "e459d41a10ce33688b5d389216a8876f">
+<!ENTITY popt-md5           "450f2f636e6a3aa527de803d0ae76c5a">
+<!ENTITY pth-md5            "9cb4a25331a4c4db866a31cbe507c793">
+<!ENTITY rpm-md5            "576277fafa5d0681a8a92c8716aca5f0">
+<!ENTITY setuptools-md5     "d9715b19a0d894539285655fd5c69109">
+<!ENTITY sqlite-md5         "f5752052fc5b8e1b539af86a3671eac7">
+<!ENTITY sqlite-doc-md5     "9abe65c7295fd0a2462f7c61f95400fd">
+<!ENTITY unzip-md5          "62b490407489521db863b523a7f86375">
+<!ENTITY unzip-patch-md5    "14c119ef7019f769497363e5cec306e0">
+<!ENTITY % general-entities SYSTEM "BOOK/general.ent">
+%general-entities;
+]>
+
+
+<!-- The first markup should be the one defined in the DOCTYPE DECLARATION -->
+<article>
+
+<!-- First section for the tarball download address.
+Only the next four lines are mandatory, but you can add anything
+to make the text look more like the LFS book.
+Do not change  anything, except the url and the md5 checksum. -->
+<sect1 id="package">
+  <?dbhtml filename="package.html"?>
+
+  <title>All Packages</title>
+        <para>Download: <ulink url="&cpio-url;"/></para>
+        <para>MD5 sum: <literal>&cpio-md5;</literal></para>
+        <para>Download: <ulink url="&libarchive-url;"/></para>
+        <para>MD5 sum: <literal>&libarchive-md5;</literal></para>
+        <para>Download: <ulink url="&libassuan-url;"/></para>
+        <para>MD5 sum: <literal>&libassuan-md5;</literal></para>
+        <para>Download: <ulink url="&libgcrypt-url;"/></para>
+        <para>MD5 sum: <literal>&libgcrypt-md5;</literal></para>
+        <para>Download: <ulink url="&libgpg-error-url;"/></para>
+        <para>MD5 sum: <literal>&libgpg-error-md5;</literal></para>
+        <para>Download: <ulink url="&libxml2-url;"/></para>
+        <para>MD5 sum: <literal>&libxml2-md5;</literal></para>
+        <para>Download: <ulink url="&libxml2-testsuite-url;"/></para>
+        <para>MD5 sum: <literal>&libxml2-testsuite-md5;</literal></para>
+        <para>Download: <ulink url="&lua-url;"/></para>
+        <para>MD5 sum: <literal>&lua-md5;</literal></para>
+        <para>Download: <ulink url="&nettle-url;"/></para>
+        <para>MD5 sum: <literal>&nettle-md5;</literal></para>
+        <para>Download: <ulink url="&pip-url;"/></para>
+        <para>MD5 sum: <literal>&pip-md5;</literal></para>
+        <para>Download: <ulink url="&popt-url;"/></para>
+        <para>MD5 sum: <literal>&popt-md5;</literal></para>
+        <para>Download: <ulink url="&pth-url;"/></para>
+        <para>MD5 sum: <literal>&pth-md5;</literal></para>
+        <para>Download: <ulink url="&rpm-url;"/></para>
+        <para>MD5 sum: <literal>&rpm-md5;</literal></para>
+        <para>Download: <ulink url="&setuptools-url;"/></para>
+        <para>MD5 sum: <literal>&setuptools-md5;</literal></para>
+        <para>Download: <ulink url="&sqlite-url;"/></para>
+        <para>MD5 sum: <literal>&sqlite-md5;</literal></para>
+        <para>Download: <ulink url="&sqlite-doc-url;"/></para>
+        <para>MD5 sum: <literal>&sqlite-doc-md5;</literal></para>
+        <para>Download: <ulink url="&unzip-url;"/></para>
+        <para>MD5 sum: <literal>&unzip-md5;</literal></para>
+</sect1>
+
+<sect1 id="patches">
+        <para>Download: <ulink url="&lua-patch-url;"/></para>
+        <para>MD5 sum: <literal>&lua-patch-md5;</literal></para>
+        <para>Download: <ulink url="&unzip-patch-url;"/></para>
+        <para>MD5 sum: <literal>&unzip-patch-md5;</literal></para>
+</sect1>
+
+<!-- Removed ch-tools as newer book is required anyway -->
+
+<!-- version for new book: needs ninja and meson, which needs
+     Python rebuilt with libffi and zlib. Needs also pkg-config -->
+<sect1 id="ch-chroot-bzip2" role="wrap">
+  <?dbhtml filename="bzip2.html"?>
+
+  <sect1info condition="script">
+    <productname>bzip2</productname>
+    <productnumber>&bzip2-version;</productnumber>
+    <address>&bzip2-url;</address>
+  </sect1info>
+
+  <title>Bzip2-&bzip2-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="pre">patch -Np1 -i ../bzip2-1.0.8-install_docs-1.patch
+sed -i 's@\(ln -s -f \)$(PREFIX)/bin/@\1@' Makefile
+sed -i "s@(PREFIX)/man@(PREFIX)/share/man@g" Makefile</userinput></screen>
+<screen><userinput remap="make">make -f Makefile-libbz2_so
+make clean
+make</userinput></screen>
+<screen><userinput remap="install">make PREFIX=/usr install
+cp -av libbz2.so.* /usr/lib
+cp -v bzip2-shared /usr/bin/bzip2
+rm -fv /usr/lib/libbz2.a
+ln -sv libbz2.so.1.0.8 /usr/lib/libbz2.so</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-libgpg-error" role="wrap">
+  <?dbhtml filename="libgpg-error.html"?>
+
+  <sect1info condition="script">
+    <productname>libgpg-error</productname>
+    <productnumber>&libgpg-error-version;</productnumber>
+    <address>&libgpg-error-url;</address>
+  </sect1info>
+
+  <title>libgpg-error-&libgpg-error-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-libassuan" role="wrap">
+  <?dbhtml filename="libassuan.html"?>
+
+  <sect1info condition="script">
+    <productname>libassuan</productname>
+    <productnumber>&libassuan-version;</productnumber>
+    <address>&libassuan-url;</address>
+  </sect1info>
+
+  <title>libassuan-&libassuan-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-pth" role="wrap">
+  <?dbhtml filename="pth.html"?>
+
+  <sect1info condition="script">
+    <productname>pth</productname>
+    <productnumber>&pth-version;</productnumber>
+    <address>&pth-url;</address>
+  </sect1info>
+
+  <title>pth-&pth-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="pre">sed -i 's#$(LOBJS): Makefile#$(LOBJS): pth_p.h Makefile#' Makefile.in</userinput></screen>
+<screen><userinput remap="configure">./configure --prefix=/usr \
+           --mandir=/usr/share/man</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-libgcrypt" role="wrap">
+  <?dbhtml filename="libgcrypt.html"?>
+
+  <sect1info condition="script">
+    <productname>libgcrypt</productname>
+    <productnumber>&libgcrypt-version;</productnumber>
+    <address>&libgcrypt-url;</address>
+  </sect1info>
+
+  <title>libgcrypt-&libgcrypt-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-libffi" role="wrap">
+  <?dbhtml filename="libffi.html"?>
+
+  <sect1info condition="script">
+    <productname>libffi</productname>
+    <productnumber>&libffi-version;</productnumber>
+    <address>&libffi-url;</address>
+  </sect1info>
+
+  <title>libffi-&libffi-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr --disable-static --with-gcc-arch=native</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-zlib" role="wrap">
+  <?dbhtml filename="zlib.html"?>
+
+  <sect1info condition="script">
+    <productname>zlib</productname>
+    <productnumber>&zlib-version;</productnumber>
+    <address>&zlib-url;</address>
+  </sect1info>
+
+  <title>zlib-&zlib-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install
+rm -fv /usr/lib/libz.a</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-openssl" role="wrap">
+  <?dbhtml filename="openssl.html"?>
+
+  <sect1info condition="script">
+    <productname>openssl</productname>
+    <productnumber>&openssl-version;</productnumber>
+    <address>&openssl-url;</address>
+  </sect1info>
+
+  <title>openssl-&openssl-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./config --prefix=/usr         \
+         --openssldir=/etc/ssl \
+         --libdir=lib          \
+         shared                \
+         zlib-dynamic</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">sed -i '/INSTALL_LIBS/s/libcrypto.a libssl.a//' Makefile
+make MANSUFFIX=ssl install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-sqlite" role="wrap">
+  <?dbhtml filename="sqlite.html"?>
+
+  <sect1info condition="script">
+    <productname>sqlite</productname>
+    <productnumber>&sqlite-short-version;</productnumber>
+    <address>&sqlite-url;</address>
+  </sect1info>
+
+  <title>sqlite-&sqlite-short-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr     \
+            --disable-static  \
+            --enable-fts5     \
+            CPPFLAGS="-DSQLITE_ENABLE_FTS3=1  \
+            -DSQLITE_ENABLE_FTS4=1            \
+            -DSQLITE_ENABLE_COLUMN_METADATA=1 \
+            -DSQLITE_ENABLE_UNLOCK_NOTIFY=1   \
+            -DSQLITE_ENABLE_DBSTAT_VTAB=1     \
+            -DSQLITE_SECURE_DELETE=1          \
+            -DSQLITE_ENABLE_FTS3_TOKENIZER=1"</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-gmp" role="wrap">
+  <?dbhtml filename="gmp.html"?>
+
+  <sect1info condition="script">
+    <productname>gmp</productname>
+    <productnumber>&gmp-version;</productnumber>
+    <address>&gmp-url;</address>
+  </sect1info>
+
+  <title>gmp-&gmp-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="pre">cp -v configfsf.guess config.guess
+cp -v configfsf.sub   config.sub</userinput></screen>
+<screen><userinput remap="configure">./configure --prefix=/usr    \
+            --enable-cxx     \
+            --disable-static \
+            --docdir=/usr/share/doc/gmp-6.2.1</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-nettle" role="wrap">
+  <?dbhtml filename="nettle.html"?>
+
+  <sect1info condition="script">
+    <productname>nettle</productname>
+    <productnumber>&nettle-version;</productnumber>
+    <address>&nettle-url;</address>
+  </sect1info>
+
+  <title>nettle-&nettle-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr --disable-static</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install
+chmod -v 755 /usr/lib/lib{hogweed,nettle}.so</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-libarchive" role="wrap">
+  <?dbhtml filename="libarchive.html"?>
+
+  <sect1info condition="script">
+    <productname>libarchive</productname>
+    <productnumber>&libarchive-version;</productnumber>
+    <address>&libarchive-url;</address>
+  </sect1info>
+
+  <title>Libarchive-&libarchive-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr \
+            --disable-static</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-expat" role="wrap">
+  <?dbhtml filename="expat.html"?>
+
+  <sect1info condition="script">
+    <productname>expat</productname>
+    <productnumber>&expat-version;</productnumber>
+    <address>&expat-url;</address>
+  </sect1info>
+
+  <title>expat-&expat-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr    \
+            --disable-static \
+            --docdir=/usr/share/doc/expat-&expat-version;</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-pkg-config" role="wrap">
+  <?dbhtml filename="pkg-config.html"?>
+
+  <sect1info condition="script">
+    <productname>pkg-config</productname>
+    <productnumber>&pkgconfig-version;</productnumber>
+    <address>&pkgconfig-url;</address>
+  </sect1info>
+
+  <title>pkgconfig-&pkgconfig-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr              \
+            --with-internal-glib       \
+            --disable-host-tool        \
+            --docdir=/usr/share/doc/pkg-config-&pkgconfig-version;</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-python" role="wrap">
+  <?dbhtml filename="python.html"?>
+
+  <sect1info condition="script">
+    <productname>python</productname>
+    <productnumber>&python-version;</productnumber>
+    <address>&python-url;</address>
+  </sect1info>
+
+  <title>Python-&python-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr        \
+            --enable-shared      \
+            --with-system-expat  \
+            --with-system-ffi    \
+            --with-ensurepip=yes \
+            --enable-optimizations</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-setuptools" role="wrap">
+  <?dbhtml filename="setuptools.html"?>
+
+  <sect1info condition="script">
+    <productname>setuptools</productname>
+    <productnumber>&setuptools-version;</productnumber>
+    <address>&setuptools-url;</address>
+  </sect1info>
+
+  <title>setuptools-&setuptools-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="make">python3 setup.py build</userinput></screen>
+<screen><userinput remap="install">python3 setup.py install --optimize=1 --skip-build</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-pip" role="wrap">
+  <?dbhtml filename="pip.html"?>
+
+  <sect1info condition="script">
+    <productname>pip</productname>
+    <productnumber>&pip-version;</productnumber>
+    <address>&pip-url;</address>
+  </sect1info>
+
+  <title>pip-&pip-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="make">python3 setup.py build</userinput></screen>
+<screen><userinput remap="install">python3 setup.py install --prefix=/usr --optimize=1
+ln -sfv pip3.9 /usr/bin/pip3
+ln -sfv pip3.9 /usr/bin/pip</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-libcap" role="wrap">
+  <?dbhtml filename="libcap.html"?>
+
+  <sect1info condition="script">
+    <productname>libcap</productname>
+    <productnumber>&libcap-version;</productnumber>
+    <address>&libcap-url;</address>
+  </sect1info>
+
+  <title>libcap-&libcap-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="make">make prefix=/usr lib=lib</userinput></screen>
+<screen><userinput remap="install">make prefix=/usr lib=lib install
+chmod -v 755 /lib/lib{cap,psx}.so.&libcap-version;
+rm -f /usr/lib/lib{cap,psx}.a</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-elfutils" role="wrap">
+  <?dbhtml filename="elfutils.html"?>
+
+  <sect1info condition="script">
+    <productname>elfutils</productname>
+    <productversion>&elfutils-version;</productversion>
+    <address>&elfutils-url;</address>
+  </sect1info>
+
+  <title>elfutils-&elfutils-version;</title>
+
+  <sect2 role="installation">>
+    <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr                \
+            --disable-debuginfod         \
+            --enable-libdebuginfod=dummy</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+</sect1>
+
+<sect1 id="ch-chroot-popt" role="wrap">
+  <?dbhtml filename="popt.html"?>
+
+  <sect1info condition="script">
+    <productname>popt</productname>
+    <productversion>&popt-version;</productversion>
+    <address>&popt-url;</address>
+  </sect1info>
+
+  <title>popt-&popt-version;</title>
+
+  <sect2 role="installation">
+  <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr --disable-static</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install</userinput></screen>
+  </sect2>
+</sect1>
+
+<sect1 id="ch-chroot-lua" role="wrap">
+  <?dbhtml filename="lua.html"?>
+
+  <sect1info condition="script">
+    <productname>lua</productname>
+    <productversion>&lua-version;</productversion>
+    <address>&lua-url;</address>
+  </sect1info>
+
+  <title>lua-&lua-version;</title>
+
+  <sect2 role="installation">
+  <title/>
+<screen><userinput remap="pre">cat &gt; lua.pc &lt;&lt; "EOF"
+V=5.4
+R=5.4.3
+
+prefix=/usr
+INSTALL_BIN=${prefix}/bin
+INSTALL_INC=${prefix}/include
+INSTALL_LIB=${prefix}/lib
+INSTALL_MAN=${prefix}/share/man/man1
+INSTALL_LMOD=${prefix}/share/lua/${V}
+INSTALL_CMOD=${prefix}/lib/lua/${V}
+exec_prefix=${prefix}
+libdir=${exec_prefix}/lib
+includedir=${prefix}/include
+
+Name: Lua
+Description: An Extensible Extension Language
+Version: ${R}
+Requires:
+Libs: -L${libdir} -llua -lm -ldl
+Cflags: -I${includedir}
+EOF
+patch -Np1 -i ../lua-5.4.3-shared_library-1.patch</userinput></screen>
+<screen><userinput remap="make">make linux</userinput></screen>
+<screen><userinput remap="install">make INSTALL_TOP=/usr                \
+     INSTALL_DATA="cp -d"            \
+     INSTALL_MAN=/usr/share/man/man1 \
+     TO_LIB="liblua.so liblua.so.5.4 liblua.so.5.4.3" \
+     install
+install -v -m644 -D lua.pc /usr/lib/pkgconfig/lua.pc</userinput></screen>
+  </sect2>
+</sect1>
+
+<sect1 id="ch-chroot-rpm" role="wrap">
+  <?dbhtml filename="rpm.html"?>
+
+  <sect1info condition="script">
+    <productname>rpm</productname>
+    <productversion>&rpm-version;</productversion>
+    <address>&rpm-url;</address>
+  </sect1info>
+
+  <title>rpm-&rpm-version;</title>
+
+  <sect2 role="installation">
+  <title/>
+<screen><userinput remap="configure">./configure --prefix=/usr        \
+            --sysconfdir=/etc    \
+            --localstatedir=/var \
+            --disable-bdb</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make install
+sed /_db_backend/s/bdb/sqlite/ -i /usr/lib/rpm/macros</userinput></screen>
+  </sect2>
+</sect1>
+
+<sect1 id="ch-chroot-shadow" role="wrap">
+  <?dbhtml filename="shadow.html"?>
+
+  <sect1info condition="script">
+    <productname>shadow</productname>
+    <productnumber>&shadow-version;</productnumber>
+    <address>&shadow-url;</address>
+  </sect1info>
+
+  <title>shadow-&shadow-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="pre">sed -e 's:#ENCRYPT_METHOD DES:ENCRYPT_METHOD SHA512:' \
+    -e 's:/var/spool/mail:/var/mail:'                 \
+    -e '/PATH=/{s@/sbin:@@;s@/bin:@@}'                \
+    -i etc/login.defs
+sed -e "224s/rounds/min_rounds/" -i libmisc/salt.c</userinput></screen>
+<screen><userinput remap="configure">touch /usr/bin/passwd
+./configure --sysconfdir=/etc \
+            --with-group-name-max-length=32</userinput></screen>
+<screen><userinput remap="make">make</userinput></screen>
+<screen><userinput remap="install">make exec_prefix=/usr install
+mkdir -p /etc/default
+useradd -D --gid 999</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<!-- It is not ideal to do build the next two packages here ( without officially
+     being in chapter08), but it gets the order correct, and we already do this
+     in LFS with the linux-api-headers package, it must be done here as well-->
+
+<sect1 id="ch-chroot-rootfs" role="wrap">
+  <?dbhtml filename="rootfs.html"?>
+
+  <sect1info condition="script">
+    <productname>rootfs</productname>
+    <productnumber>1.0</productnumber>
+    <address>https://www.linuxfromscratch.org/</address>
+  </sect1info>
+
+  <title>rootfs-1.0</title>
+
+  <sect2 role="installation">
+    <title/>
+
+<screen><userinput remap="install"># Not actually part of the package, but this needs to be done now...
+# Delete all man/info pages, documentation, and libtool archives
+rm -rf /usr/share/man/*
+rm -f /usr/share/info/*
+rm -rf /usr/share/doc/*
+find /usr/{lib,libexec} -name \*.la -delete
+rpm --initdb --root=/
+mkdir -p ~/rpmbuild/{BUILD,RPMS,SOURCES,SPECS,SRPMS,BUILDROOT}
+
+# Here we create our first pacakge
+# Note: this combines many sections from LFS and configuration files that
+# will be overwritten as jhalfs progresses
+mkdir -p rootfs
+cd rootfs
+cat &gt; rootfs.spec &lt;&lt; "REALEOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: rootfs
+Version: 1.0
+Release: 1
+Summary: Basic root filesystem
+License: Creative Commons Attribution-NonCommercial-ShareAlike 4.0
+Group: base
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+
+%description
+Contains the basic root filesystem layout and initial configuration files
+
+%prep
+# Nothing to do
+
+%build
+# Nothing to do
+
+%install
+# LFS Section 4.2
+install -vdm755 %{buildroot}/{etc,lib64,usr/{bin,lib,sbin},var}
+for i in bin lib sbin; do
+  ln -sv usr/$i %{buildroot}/$i
+done
+
+# LFS Section 7.3
+install -vdm755 %{buildroot}/{dev,proc,run,sys}
+
+# LFS Section 7.3.1
+mknod -m 666 %{buildroot}/dev/console c 5 1
+mknod -m 666 %{buildroot}/dev/null c 1 3
+
+# LFS Section 7.5
+install -vdm755 %{buildroot}/{boot,home,mnt,opt,srv}
+install -vdm755 %{buildroot}/etc/{opt,sysconfig}
+install -vdm755 %{buildroot}/usr/lib/firmware
+install -vdm755 %{buildroot}/media/{floppy,cdrom}
+install -vdm755 %{buildroot}/usr/{,local/}{bin,include,lib,sbin,src}
+install -vdm755 %{buildroot}/usr/{,local/}share/{color,dict,doc,info,locale,man}
+install -vdm755 %{buildroot}/usr/{,local/}share/{misc,terminfo,zoneinfo}
+install -vdm755 %{buildroot}/usr/{,local/}share/man/man{1,2,3,4,5,6,7,8}
+install -vdm755 %{buildroot}/var/{cache,local,log,mail,opt,spool}
+install -vdm755 %{buildroot}/var/lib/{color,misc,locate}
+install -vdm750 %{buildroot}/root
+install -vdm1777 %{buildroot}{,/var}/tmp
+ln -sfv /run %{buildroot}/var/run
+ln -sfv /run/lock %{buildroot}/var/lock
+
+# LFS Section 7.6
+ln -sv /proc/self/mounts %{buildroot}/etc/mtab
+cat &gt; %{buildroot}/etc/passwd &lt;&lt; "EOF"
+root:x:0:0:root:/root:/bin/bash
+bin:x:1:1:bin:/dev/null:/bin/false
+daemon:x:6:6:Daemon User:/dev/null:/bin/false
+messagebus:x:18:18:D-Bus Message Daemon User:/run/dbus:/bin/false
+uuidd:x:80:80:UUID Generation Daemon User:/dev/null:/bin/false
+nobody:x:99:99:Unprivileged User:/dev/null:/bin/false
+tester:x:1001:101::/home/tester:/bin/bash
+EOF
+cat &gt; %{buildroot}/etc/group &lt;&lt; "EOF"
+root:x:0:
+bin:x:1:daemon
+sys:x:2:
+kmem:x:3:
+tape:x:4:
+tty:x:5:
+daemon:x:6:
+floppy:x:7:
+disk:x:8:
+lp:x:9:
+dialout:x:10:
+audio:x:11:
+video:x:12:
+utmp:x:13:
+usb:x:14:
+cdrom:x:15:
+adm:x:16:
+messagebus:x:18:
+input:x:24:
+mail:x:34:
+kvm:x:61:
+uuidd:x:80:
+wheel:x:97:
+nogroup:x:99:
+users:x:999:
+tester:x:101:
+EOF
+
+touch %{buildroot}/var/log/{btmp,lastlog,faillog,wtmp}
+chgrp -v utmp %{buildroot}/var/log/lastlog
+chmod -v 664  %{buildroot}/var/log/lastlog
+chmod -v 600  %{buildroot}/var/log/btmp
+
+# LFS Sections 7.6 and 9.5.4
+cat &gt; %{buildroot}/etc/hosts &lt;&lt; "EOF"
+# Begin /etc/hosts
+
+# IPv4
+127.0.0.1 localhost.localdomain localhost
+# Populate the follwoing lines after installation
+#127.0.1.1 &lt;FQDN&gt; &lt;HOSTNAME&gt;
+#&lt;192.168.1.1&gt; &lt;FQDN&gt; &lt;HOSTNAME&gt; [alias1] [alias2 ...]
+
+# IPv6
+::1       localhost ip6-localhost ip6-loopback
+ff02::1   ip6-allnodes
+ff02::2   ip6-allrouters
+
+# End /etc/hosts
+EOF
+
+# LFS Section 8.5.2.3
+install -vdm755 %{buildroot}/etc/ld.so.conf.d/
+cat &gt; %{buildroot}/etc/ld.so.conf &lt;&lt; "EOF"
+# Begin /etc/ld.so.conf
+
+/usr/local/lib
+/opt/lib
+
+# Add an include directory
+include /etc/ld.so.conf.d/*.conf
+
+# End /etc/ld.so.conf
+EOF
+
+# LFS Section 9.5.2
+cat &gt; %{buildroot}/etc/resolv.conf &lt;&lt; "EOF"
+# Begin /etc/resolv.conf
+
+domain localdomain
+nameserver 8.8.8.8
+nameserver 8.8.4.4
+
+# End /etc/resolv.conf
+EOF
+
+# LFS Section 9.5.3
+echo "lfs" &gt; %{buildroot}/etc/hostname
+
+# LFS Section 9.8
+cat &gt; %{buildroot}/etc/inputrc &lt;&lt; "EOF"
+# Begin /etc/inputrc
+# Modified by Chris Lynn &lt;roryo@roryo.dynup.net&gt;
+
+# Allow the command prompt to wrap to the next line
+set horizontal-scroll-mode Off
+
+# Enable 8bit input
+set meta-flag On
+set input-meta On
+
+# Turns off 8th bit stripping
+set convert-meta Off
+
+# Keep the 8th bit for display
+set output-meta On
+
+# none, visible or audible
+set bell-style none
+
+# All of the following map the escape sequence of the value
+# contained in the 1st argument to the readline specific functions
+"\eOd": backward-word
+"\eOc": forward-word
+
+# for linux console
+"\e[1~": beginning-of-line
+"\e[4~": end-of-line
+"\e[5~": beginning-of-history
+"\e[6~": end-of-history
+"\e[3~": delete-char
+"\e[2~": quoted-insert
+
+# for xterm
+"\eOH": beginning-of-line
+"\eOF": end-of-line
+
+# for Konsole
+"\e[H": beginning-of-line
+"\e[F": end-of-line
+
+# End /etc/inputrc
+EOF
+
+  # LFS Section 9.9
+  cat &gt; %{buildroot}/etc/shells &lt;&lt; "EOF"
+# Begin /etc/shells
+
+/bin/sh
+/bin/bash
+
+# End /etc/shells
+EOF
+
+# LFS Section 10.2
+cat &gt; %{buildroot}/etc/fstab &lt;&lt; "EOF"
+# Begin /etc/fstab
+
+# file system  mount-point  type     options             dump  fsck
+#                                                              order
+/dev/&lt;xxx&gt;     /            &lt;fff&gt;    defaults            1     1
+/dev/&lt;yyy&gt;     swap         swap     pri=1               0     0
+proc           /proc        proc     nosuid,noexec,nodev 0     0
+sysfs          /sys         sysfs    nosuid,noexec,nodev 0     0
+devpts         /dev/pts     devpts   gid=5,mode=620      0     0
+tmpfs          /run         tmpfs    defaults            0     0
+devtmpfs       /dev         devtmpfs mode=0755,nosuid    0     0
+
+# End /etc/fstab
+EOF
+
+# Post LFS fixes:
+touch %{buildroot}/usr/share/info/dir
+chmod 0644 %{buildroot}/usr/share/info/dir
+touch %{buildroot}/etc/ld.so.cache
+chmod 0644 %{buildroot}/etc/ld.so.cache
+chmod 0555 %{buildroot}/proc
+chmod 1777 %{buildroot}/run
+chmod 0555 %{buildroot}/sys
+
+#### Generic addition to install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed -i '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed -i '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+%pre
+# Nothing to do
+
+%post
+# Nothing to do
+
+%preun
+# Nothing to do
+
+%postun
+# Nothing to do
+
+REALEOF
+mv rootfs.spec /root/rpmbuild/SPECS
+rpmbuild -ba /root/rpmbuild/SPECS/rootfs.spec
+rpm --install --nodeps --justdb \
+    /root/rpmbuild/RPMS/$(uname -m)/rootfs-1.0-1.$(uname -m).rpm
+rpm --install --nodeps --replacepkgs \
+    /root/rpmbuild/RPMS/$(uname -m)/rootfs-1.0-1.$(uname -m).rpm
+rm -rf /root/rpmbuild/BUILDROOT/rootfs-1.0/</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-chroot-linux-api-headers" role="wrap">
+  <?dbhtml filename="linux-api-headers.html"?>
+
+  <sect1info condition="script">
+    <productname>linux-api-headers</productname>
+    <productnumber>&linux-version;</productnumber>
+    <address>&linux-url;</address>
+  </sect1info>
+
+  <title>linux-api-headers-&linux-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+
+<screen><userinput remap="install">mkdir linux-api-headers
+cd linux-api-headers
+cat &gt; linux-api-headers.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: linux-api-headers
+Version: &linux-version;
+Release: 1
+Summary: Linux API Headers
+License: LGPL
+Group: base
+BuildRequires: bash binutils coreutils findutils gcc glibc grep gzip make perl sed
+Requires: rootfs
+Source: linux-&linux-version;.tar.xz
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+The Linux API Headers expose the kernel's API for use by Glibc.
+
+%prep
+%setup -n linux-%{version}
+make mrproper
+
+%build
+make headers
+find usr/include -name '.*' -delete
+rm usr/include/Makefile
+
+%check
+# Nothing to do
+
+%install
+mkdir -pv %{buildroot}/usr
+cp -rv usr/include %{buildroot}/usr/
+
+#### Generic addition to install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+%pre
+# Nothing to do
+
+%post
+# Nothing to do
+
+%preun
+# Nothing to do
+
+%postun
+# Nothing to do
+
+EOF
+mv linux-api-headers.spec /root/rpmbuild/SPECS/
+cp /sources/linux-&linux-version;.tar.xz /root/rpmbuild/SOURCES/
+rpmbuild -ba --nodeps /root/rpmbuild/SPECS/linux-api-headers.spec
+rpm --install --nodeps --justdb \
+    /root/rpmbuild/RPMS/$(uname -m)/linux-api-headers-&linux-version;-1.$(uname -m).rpm
+rpm --install --nodeps --replacepkgs \
+    /root/rpmbuild/RPMS/$(uname -m)/linux-api-headers-&linux-version;-1.$(uname -m).rpm
+rm -rf /root/rpmbuild/BUILD/linux-api-headers-&linux-version;</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+<!-- Mandatory section for creating dirs. These instructions are added at the
+end of the creating dirs instructions of the book. Do not change the
+following line -->
+<sect1 id="ch-pkgmngt-creatingdirs">
+
+  <title>Creating Directories</title>
+
+<screen><userinput> </userinput></screen>
+
+</sect1>
+<!-- Same for files. Do not change the following line -->
+<sect1 id="ch-pkgmngt-createfiles">
+
+  <title>Creating Essential Files</title>
+
+<screen><userinput> </userinput></screen>
+
+</sect1>
+
+<!-- Last but not least : Final instructions for installing the
+package manager at the end of chapter 6. Again, the scriptlet file name is
+taken from the dbhtml instruction, with digits added before and .html cut
+and the tarball name is formed from this name + version. So the file
+here _must_ be the same as in chapter 5. If rendering in html, both
+sets of instructions end up in the same file, which is usually not a problem.
+-->
+
+<sect1 id="ch-system-base" role="wrap">
+  <?dbhtml filename="base.html"?>
+
+  <sect1info condition="script">
+    <productname>base</productname>
+    <productnumber>1.0</productnumber>
+    <address>&lfs-root;</address>
+  </sect1info>
+
+  <title>Base metapackage</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">REQUIRES=""
+for package in $(rpm -qa | sed 's@-[0-9].*@@'); do
+  REQUIRES="${REQUIRES} ${package}"
+done
+cat &gt; base.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: base
+Version: 1.0
+Release: 1
+Summary: base 1.0
+License: CC-BY-SA
+EOF
+echo "Requires: ${REQUIRES}" &gt;&gt; base.spec
+cat &gt;&gt; base.spec &lt;&lt; "EOF"
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+A metapackage that contians all LFS base packages for easier dependency
+management.
+
+%files
+
+EOF</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-libgpg-error" role="wrap">
+  <?dbhtml filename="libgpg-error.html"?>
+
+  <sect1info condition="script">
+    <productname>libgpg-error</productname>
+    <productnumber>&libgpg-error-version;</productnumber>
+    <address>&libgpg-error-url;</address>
+  </sect1info>
+
+  <title>libgpg-error-&libgpg-error-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; libgpg-error.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: libgpg-error
+Version: &libgpg-error-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Source0: libgpg-error-&libgpg-error-version;.tar.bz2
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}-%{version}
+
+%build
+./configure --prefix=/usr
+make
+
+%check
+make check
+
+%install
+make DESTDIR="%{buildroot}" install
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-libassuan" role="wrap">
+  <?dbhtml filename="libassuan.html"?>
+
+  <sect1info condition="script">
+    <productname>libassuan</productname>
+    <productnumber>&libassuan-version;</productnumber>
+    <address>&libassuan-url;</address>
+  </sect1info>
+
+  <title>libassuan-&libassuan-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; libassuan.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: libassuan
+Version: &libassuan-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base
+BuildRequires: base libgpg-error
+Requires: base libgpg-error
+Source0: libassuan-&libassuan-version;.tar.bz2
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup %{name}-%{version}
+
+%build
+./configure --prefix=/usr
+make
+
+%check
+make check
+
+%install
+make DESTDIR="%{buildroot}" install
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-pth" role="wrap">
+  <?dbhtml filename="pth.html"?>
+
+  <sect1info condition="script">
+    <productname>pth</productname>
+    <productnumber>&pth-version;</productnumber>
+    <address>&pth-url;</address>
+  </sect1info>
+
+  <title>pth-&pth-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; pth.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: pth
+Version: &pth-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Source0: pth-&pth-version;.tar.gz
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}-%{version}
+sed -i 's#$(LOBJS): Makefile#$(LOBJS): pth_p.h Makefile#' Makefile.in
+
+%build
+./configure --prefix=/usr \
+            --mandir=/usr/share/man
+make
+
+%check
+make check
+
+%install
+make -j1 DESTDIR="%{buildroot}" install
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-libgcrypt" role="wrap">
+  <?dbhtml filename="libgcrypt.html"?>
+
+  <sect1info condition="script">
+    <productname>libgcrypt</productname>
+    <productnumber>&libgcrypt-version;</productnumber>
+    <address>&libgcrypt-url;</address>
+  </sect1info>
+
+  <title>libgcrypt-&libgcrypt-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; libgcrypt.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: libgcrypt
+Version: &libgcrypt-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Suggests: libedit
+Source0: libgcrypt-&libgcrypt-version;.tar.bz2
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup %{name}-%{version}
+
+%build
+./configure --prefix=/usr
+make
+
+%check
+make check
+
+%install
+make DESTDIR="%{buildroot}" install
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-unzip" role="wrap">
+  <?dbhtml filename="unzip.html"?>
+
+  <sect1info condition="script">
+    <productname>unzip</productname>
+    <productnumber>&unzip-version;</productnumber>
+    <address>&unzip-url;</address>
+  </sect1info>
+
+  <title>unzip-&unzip-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; unzip.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: unzip
+Version: &unzip-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Source0: unzip60.tar.gz
+Patch0: &unzip-patch;
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&gt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}60
+%patch0 -p1
+
+%build
+make -f unix/Makefile generic
+
+%install
+make prefix=%{buildroot}/usr MANDIR=%{buildroot}/usr/share/man/man1 \
+     -f unix/Makefile install
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-sqlite" role="wrap">
+  <?dbhtml filename="sqlite.html"?>
+
+  <sect1info condition="script">
+    <productname>sqlite</productname>
+    <productnumber>&sqlite-version;</productnumber>
+    <address>&sqlite-url;</address>
+  </sect1info>
+
+  <title>sqlite-&sqlite-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; sqlite.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: sqlite
+Version: &sqlite-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Suggests: libedit
+Source0: sqlite-autoconf-&sqlite-short-version;.tar.gz
+Source1: sqlite-doc-&sqlite-short-version;.zip
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}-autoconf-&sqlite-short-version;
+unzip -q ../../SOURCES/sqlite-doc-&sqlite-short-version;.zip
+
+%build
+./configure --prefix=/usr     \
+            --disable-static  \
+            --enable-fts5     \
+            CPPFLAGS="-DSQLITE_ENABLE_FTS3=1  \
+            -DSQLITE_ENABLE_FTS4=1            \
+            -DSQLITE_ENABLE_COLUMN_METADATA=1 \
+            -DSQLITE_ENABLE_UNLOCK_NOTIFY=1   \
+            -DSQLITE_ENABLE_DBSTAT_VTAB=1     \
+            -DSQLITE_SECURE_DELETE=1          \
+            -DSQLITE_ENABLE_FTS3_TOKENIZER=1"
+make
+
+%check
+make check
+
+%install
+make DESTDIR="%{buildroot}" install
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-nettle" role="wrap">
+  <?dbhtml filename="nettle.html"?>
+
+  <sect1info condition="script">
+    <productname>nettle</productname>
+    <productnumber>&nettle-version;</productnumber>
+    <address>&nettle-url;</address>
+  </sect1info>
+
+  <title>nettle-&nettle-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; nettle.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: nettle
+Version: &nettle-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Suggests: valgrind
+Source0: nettle-&nettle-version;.tar.gz
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup %{name}-%{version}
+
+%build
+./configure --prefix=/usr --disable-static
+make
+
+%check
+make check
+
+%install
+make DESTDIR="%{buildroot}" install
+chmod -v 755    %{buildroot}/usr/lib/lib{hogweed,nettle}.so
+install -vdm755 %{buildroot}/usr/share/doc/nettle-%{version}
+install -vm644  nettle.html %{buildroot}/usr/share/doc/nettle-%{version}
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-libxml2" role="wrap">
+  <?dbhtml filename="libxml2.html"?>
+
+  <sect1info condition="script">
+    <productname>libxml2</productname>
+    <productnumber>&libxml2-version;</productnumber>
+    <address>&libxml2-url;</address>
+  </sect1info>
+
+  <title>libxml2-&libxml2-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; libxml2.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: libxml2
+Version: &libxml2-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Suggests: icu valgrind
+Source0: libxml2-&libxml2-version;.tar.gz
+Source1: &libxml2-testsuite;
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup %{name}-%{version}
+
+%build
+./configure --prefix=/usr    \
+            --disable-static \
+            --with-history   \
+            --with-python=/usr/bin/python3
+make
+
+%check
+tar -xf ../../SOURCES/&libxml2-testsuite;
+make check
+
+%install
+make DESTDIR="%{buildroot}" install
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+  </sect2>
+
+</sect1>
+
+
+<sect1 id="ch-system-libarchive" role="wrap">
+  <?dbhtml filename="libarchive.html"?>
+
+  <sect1info condition="script">
+    <productname>libarchive</productname>
+    <productnumber>&libarchive-version;</productnumber>
+    <address>&libarchive-url;</address>
+  </sect1info>
+
+  <title>libarchive-&libarchive-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; libarchive.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: libarchive
+Version: &libarchive-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base libxml2 nettle
+Requires: base libxml2 nettle
+Suggests: lzo
+Source0: libarchive-&libarchive-version;.tar.xz
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup %{name}-%{version}
+
+%build
+./configure --prefix=/usr --disable-static
+make
+
+%check
+LC_ALL=C make check
+
+%install
+make DESTDIR="%{buildroot}" install
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-setuptools" role="wrap">
+  <?dbhtml filename="setuptools.html"?>
+
+  <sect1info condition="script">
+    <productname>setuptools</productname>
+    <productnumber>&setuptools-version;</productnumber>
+    <address>&setuptools-url;</address>
+  </sect1info>
+
+  <title>setuptools-&setuptools-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; setuptools.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: setuptools
+Version: &setuptools-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Source0: setuptools-&setuptools-version;.tar.gz
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}-%{version}
+
+%build
+python3 setup.py build
+
+%install
+python3 setup.py install --prefix=/usr --root="%{buildroot}" --optimize=1 --skip-build
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+## Special case for setuptools - it has spaces in filenames
+sed '/launcher manifest/s@^/@"/@' -i files.%{name}
+sed '/launcher manifest/s@xml@xml"@' -i files.%{name}
+sed '/script (dev)/s@^/@"/@' -i files.%{name}
+sed '/script (dev)/s@tmpl@tmpl"@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-pip" role="wrap">
+  <?dbhtml filename="pip.html"?>
+
+  <sect1info condition="script">
+    <productname>pip</productname>
+    <productnumber>&pip-version;</productnumber>
+    <address>&pip-url;</address>
+  </sect1info>
+
+  <title>pip-&pip-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; pip.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: pip
+Version: &pip-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base setuptools
+Requires: base
+Source0: pip-&pip-version;.tar.gz
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}-%{version}
+
+%build
+python3 setup.py build
+
+%install
+python3 setup.py install --prefix=/usr --root="%{buildroot}" --optimize=1
+ln -sfv pip3.9 %{buildroot}/usr/bin/pip3
+ln -sfv pip3.9 %{buildroot}/usr/bin/pip
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-popt" role="wrap">
+  <?dbhtml filename="popt.html"?>
+
+  <sect1info condition="script">
+    <productname>popt</productname>
+    <productnumber>&popt-version;</productnumber>
+    <address>&popt-url;</address>
+  </sect1info>
+
+  <title>popt-&popt-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; popt.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: popt
+Version: &popt-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Suggests: doxygen
+Source0: popt-&popt-version;.tar.gz
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}-%{version}
+
+%build
+./configure --prefix=/usr --disable-static
+make
+
+%check
+make check
+
+%install
+make DESTDIR="%{buildroot}" install
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-lua" role="wrap">
+  <?dbhtml filename="lua.html"?>
+
+  <sect1info condition="script">
+    <productname>lua</productname>
+    <productnumber>&lua-version;</productnumber>
+    <address>&lua-url;</address>
+  </sect1info>
+
+  <title>lua-&lua-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; lua.spec &lt;&lt; "REALEOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: lua
+Version: &lua-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Source0: lua-&lua-version;.tar.gz
+Patch0: &lua-patch;
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}-%{version}
+cat &gt; lua.pc &lt;&lt; "EOF"
+V=&lua-minor;
+R=&lua-version;
+
+prefix=/usr
+INSTALL_BIN=${prefix}/bin
+INSTALL_INC=${prefix}/include
+INSTALL_LIB=${prefix}/lib
+INSTALL_MAN=${prefix}/share/man/man1
+INSTALL_LMOD=${prefix}/share/lua/${V}
+INSTALL_CMOD=${prefix}/lib/lua/${V}
+exec_prefix=${prefix}
+libdir=${exec_prefix}/lib
+includedir=${prefix}/include
+
+Name: Lua
+Description: An Extensible Extension Language
+Version: ${R}
+Requires:
+Libs: -L${libdir} -llua -lm -ldl
+Cflags: -I${includedir}
+EOF
+%patch0 -p1
+
+%build
+make linux
+
+%check
+make test
+
+%install
+make INSTALL_TOP=%{buildroot}/usr                     \
+     INSTALL_DATA="cp -d"                             \
+     INSTALL_MAN=%{buildroot}/usr/share/man/man1      \
+     TO_LIB="liblua.so liblua.so.&lua-minor; liblua.so.&lua-version;" \
+     install
+install -vdm755 %{buildroot}/usr/share/doc/lua-&lua-version;
+install -vm644 doc/*.{html,css,gif,png} \
+    %{buildroot}/usr/share/doc/lua-&lua-version;
+install -vdm755 %{buildroot}/usr/lib/pkgconfig
+install -vm644 lua.pc %{buildroot}/usr/lib/pkgconfig
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+REALEOF</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-cpio" role="wrap">
+  <?dbhtml filename="cpio.html"?>
+
+  <sect1info condition="script">
+    <productname>cpio</productname>
+    <productnumber>&cpio-version;</productnumber>
+    <address>&cpio-url;</address>
+  </sect1info>
+
+  <title>cpio-&rpm-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; cpio.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: cpio
+Version: &cpio-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base
+Requires: base
+Suggests: tex
+Source0: cpio-&cpio-version;.tar.bz2
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}-%{version}
+sed -i '/The name/,+2 d' src/global.c
+
+%build
+./configure --prefix=/usr \
+            --enable-mt   \
+            --with-rmt=/usr/libexec/rmt
+make
+makeinfo --html            -o doc/html      doc/cpio.texi
+makeinfo --html --no-split -o doc/cpio.html doc/cpio.texi
+makeinfo --plaintext       -o doc/cpio.txt  doc/cpio.texi
+
+%check
+make check
+
+%install
+make DESTDIR="%{buildroot}" install
+install -vdm755 %{buildroot}/usr/share/doc/%{name}-%{version}/html
+install -vm644  doc/html/* \
+                %{buildroot}/usr/share/doc/%{name}-%{version}/html
+install -vm644  doc/cpio.{html,txt} \
+                %{buildroot}/usr/share/doc/%{name}-%{version}
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-rpm" role="wrap">
+  <?dbhtml filename="rpm.html"?>
+
+  <sect1info condition="script">
+    <productname>rpm</productname>
+    <productnumber>&rpm-version;</productnumber>
+    <address>&rpm-url;</address>
+  </sect1info>
+
+  <title>rpm-&rpm-version;</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; rpm.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: rpm
+Version: &rpm-version;
+Release: 1
+Summary: %{name} %{version}
+License:
+Group: base-rpm
+BuildRequires: base libarchive lua
+Requires: base libarchive lua
+Suggests: berkeley-db cpio
+Source0: rpm-&rpm-version;.tar.bz2
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+%{name} %{version}
+
+%prep
+%setup -n %{name}-%{version}
+
+%build
+./configure --prefix=/usr        \
+            --sysconfdir=/etc    \
+            --localstatedir=/var \
+            --disable-bdb
+make
+
+%check
+make check
+
+%install
+make DESTDIR="%{buildroot}" install
+sed /_db_backend/s/bdb/sqlite/ -i %{buildroot}/usr/lib/rpm/macros
+rmdir %{buildroot}/var/tmp
+
+#### Generic addition to %install for all specs to generate installed files list
+find %{buildroot} -type f -name "*.la" -delete
+rm -f %{buildroot}/usr/share/info/dir
+find %{buildroot} -not -type d > files.%{name}
+sed  's@^%{buildroot}@@' -i files.%{name}
+find %{buildroot} -type d > dirs.%{name}
+sed  's@^%{buildroot}@@' -i dirs.%{name}
+sed '/\/etc\//s@^/@%config /@' -i files.%{name}
+sed '/\/var\/log\//s@^/@%config /@' -i files.%{name}
+sed '/\/usr\/share\/info\//s@$@.gz@' -i files.%{name}
+sed '/\/usr\/share\/man\//s@$@.gz@' -i files.%{name}
+sed 's@^/@%dir /@' dirs.%{name} >> files.%{name}
+
+#### The files section is also generic for all specs
+%files -f files.%{name}
+%defattr(-,root,root)
+
+#### The Changelog is also generic for all specs
+%changelog
+* %{date} %{pname}
+  %{pmail} %{version}-%{release}
+  Initial build
+
+EOF</userinput></screen>
+  </sect2>
+
+</sect1>
+
+<sect1 id="ch-system-base-rpm" role="wrap">
+  <?dbhtml filename="base-rpm.html"?>
+
+  <sect1info condition="script">
+    <productname>base-rpm</productname>
+    <productnumber>1.0</productnumber>
+    <address>&lfs-root;</address>
+  </sect1info>
+
+  <title>Base-rpm metapackage</title>
+
+  <sect2 role="installation">
+    <title/>
+<screen><userinput remap="install">cat &gt; base-rpm.spec &lt;&lt; "EOF"
+Packager: Linux From Scratch &lt;lfs-dev@linuxfromscratch.org&gt;
+Name: base-rpm
+Version: 1.0
+Release: 1
+Summary: base-rpm 1.0
+License: CC-BY-SA
+Requires: base cpio libarchive libassuan libgcrypt libgpg-error lua nettle pip popt pth rpm setuptools sqlite unzip
+
+# Define changelog info
+%define date %(date +"%a %b %d %Y")
+%define pname "Linux From Scratch"
+%define pmail "&lt;lfs-dev@linuxfromscrtach.org&gt;"
+%define postinsttasks ""
+
+%description
+A metapackage that contians all rpm specfic additional packages for easier
+dependency management.
+
+%files
+
+EOF</userinput></screen>
+
+  </sect2>
+
+</sect1>
+
+</article>
